Public Class cTelnetCmd

    Public Sub ShowUsers(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry

        Dim objLoginList As New ArrayList
        objReg.EnumLogin(objLoginList)

        objTelnetClient.SendCommand("ShowUsers", objLoginList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub UserInfo(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sLogin As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        Dim objLoginReg As New cLoginReg
        Dim objSendParamList As New ArrayList

        If objReg.GetLogin(sLogin, objLoginReg) = False Then

            objSendParamList.Add("User not found.")
            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub

        End If

        objSendParamList.Add(sLogin)
        objSendParamList.Add(objLoginReg.m_sPassword)
        objSendParamList.Add(objLoginReg.m_sCodec)

        If (objLoginReg.m_bStealth) Then
            objSendParamList.Add("STEALTH-YES")
        Else
            objSendParamList.Add("STEALTH-NO")
        End If

        If (objLoginReg.m_bBlock) Then
            objSendParamList.Add("BLOCK-YES")
        Else
            objSendParamList.Add("BLOCK-NO")
        End If

        objTelnetClient.SendCommand("UserInfo", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")



    End Sub

    Public Sub AddUser(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sLogin As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        Dim objLoginReg As New cLoginReg

        objLoginReg.m_sPassword = objParamList.Item(1)
        objLoginReg.m_sCodec = objParamList.Item(2)

        objLoginReg.m_bStealth = (objParamList.Item(3) = "STEALTH-YES")
        objLoginReg.m_bBlock = (objParamList.Item(4) = "BLOCK-YES")

        Dim bUpdate As Boolean = objReg.IsLoginExist(sLogin)
        Dim objSendParamList As New ArrayList

        If objReg.SetLogin(sLogin, objLoginReg) = False Then
            objSendParamList.Add("Unable to add user.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")
            Exit Sub
        End If

        objSendParamList.Add(sLogin)

        If (bUpdate) Then
            objTelnetClient.SendCommand("UpdateUser", objSendParamList)
        Else
            objTelnetClient.SendCommand("AddUser", objSendParamList)
        End If

        objTelnetClient.SendText("VaxTele:>")


    End Sub

    Public Sub RemoveUser(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sLogin As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        Dim objSendParamList As New ArrayList

        If objReg.RemoveLogin(sLogin) = False Then

            objSendParamList.Add("Unable to remove user.")
            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sLogin)

        objTelnetClient.SendCommand("RemoveUser", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '/**********************************************/

    Public Sub ShowQueues(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry
        Dim objQueueList As New ArrayList

        objReg.EnumQueue(objQueueList)

        objTelnetClient.SendCommand("ShowQueues", objQueueList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub QueueInfo(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sQueueName As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        Dim objQueueReg As New cQueueReg
        Dim objSendParamList As New ArrayList

        If objReg.GetQueue(sQueueName, objQueueReg) = False Then

            objSendParamList.Add("Queue not found.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sQueueName)
        objSendParamList.Add(objQueueReg.m_sPlayWave)
        objSendParamList.Add(objQueueReg.m_sPressDigitPlayWave)

        '////////////////////////////////////////////

        Dim sQueueOPList As String = ""

        PrepareToStr(objQueueReg.m_objQueueOPList, sQueueOPList)
        objSendParamList.Add(sQueueOPList)

        '////////////////////////////////////////////

        Dim sPressDigitList As String = ""

        PrepareToStr(objQueueReg.m_objPressDigitList, sPressDigitList)
        objSendParamList.Add(sPressDigitList)

        '////////////////////////////////////////////

        Dim sPressDigitUserList As String = ""

        PrepareToStr(objQueueReg.m_objPressDigitUserList, sPressDigitUserList)
        objSendParamList.Add(sPressDigitUserList)

        '////////////////////////////////////////////

        objTelnetClient.SendCommand("QueueInfo", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub AddQueue(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sQueueName As String = objParamList.Item(0)

        '///////////////////////////////////////

        Dim bUpdate As Boolean = Not cServerSIP.m_objServerSIP.m_objQueueList.FindQueue(sQueueName) Is Nothing

        '///////////////////////////////////////

        Dim sPlayWave As String = objParamList.Item(1)
        Dim sPressDigitPlayWave As String = objParamList.Item(2)

        '///////////////////////////////////////

        Dim objQueueOPList As New ArrayList
        ParseToList(objParamList.Item(3), objQueueOPList)

        '///////////////////////////////////////

        Dim objPressDigitList As New ArrayList
        ParseToList(objParamList.Item(4), objPressDigitList)

        '///////////////////////////////////////

        Dim objPressDigitUserList As New ArrayList
        ParseToList(objParamList.Item(5), objPressDigitUserList)

        '///////////////////////////////////////

        Dim objSendParamList As New ArrayList

        If Not cServerSIP.m_objServerSIP.m_objQueueList.AddQueue(sQueueName, sPlayWave, sPressDigitPlayWave, objQueueOPList, objPressDigitList, objPressDigitUserList) Then

            objSendParamList.Add("Unable to add queue.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sQueueName)

        If (bUpdate) Then
            objTelnetClient.SendCommand("UpdateQueue", objSendParamList)
        Else
            objTelnetClient.SendCommand("AddQueue", objSendParamList)
        End If

        objTelnetClient.SendText("VaxTele:>")
    End Sub


    Public Sub RemoveQueue(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sQueueName As String = objParamList.Item(0)
        cServerSIP.m_objServerSIP.m_objQueueList.RemoveQueue(sQueueName)

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(sQueueName)

        objTelnetClient.SendCommand("RemoveQueue", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")
    End Sub

    '/**********************************************/

    Public Sub ShowLines(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry

        Dim objLineList As New ArrayList
        objReg.EnumLine(objLineList)

        objTelnetClient.SendCommand("ShowLines", objLineList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub LineInfo(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sLineName As String = objParamList.Item(0)

        Dim objReg As New cRegistry

        Dim objLineReg As New cLineReg
        Dim objSendParamList As New ArrayList

        If objReg.GetLine(sLineName, objLineReg) = False Then

            objSendParamList.Add("Line not found.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sLineName)

        objSendParamList.Add(objLineReg.m_sDisplayName)
        objSendParamList.Add(objLineReg.m_sUserName)
        objSendParamList.Add(objLineReg.m_sAuthUser)
        objSendParamList.Add(objLineReg.m_sPassword)
        objSendParamList.Add(objLineReg.m_sRealm)
        objSendParamList.Add(objLineReg.m_sProxy)
        objSendParamList.Add(objLineReg.m_sOutboundProxy)
        objSendParamList.Add(objLineReg.m_sCodec)

        If objLineReg.m_bRegister = True Then
            objSendParamList.Add("REGISTER-YES")
        Else
            objSendParamList.Add("REGISTER-NO")
        End If


        objSendParamList.Add(objLineReg.m_sInCallType)
        objSendParamList.Add(objLineReg.m_sInCallTo)

        objTelnetClient.SendCommand("LineInfo", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub


    Public Sub AddLine(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sLineName As String = objParamList.Item(0)
        Dim sDisplayName As String = objParamList.Item(1)
        Dim sUserName As String = objParamList.Item(2)
        Dim sAuthUser As String = objParamList.Item(3)
        Dim sAuthPwd As String = objParamList.Item(4)
        Dim sRealm As String = objParamList.Item(5)
        Dim sProxy As String = objParamList.Item(6)
        Dim sOutboundProxy As String = objParamList.Item(7)
        Dim sCodec As String = objParamList.Item(8)

        Dim bRegister As Boolean = (objParamList.Item(9) = "REGISTER-YES")

        Dim sInCallType As String = objParamList.Item(10)
        Dim sInCallTo As String = objParamList.Item(11)

        Dim bUpdate As Boolean = (Not cServerSIP.m_objServerSIP.m_objLineList.FindLine(sLineName) Is Nothing)

        Dim objSendParamList As New ArrayList

        If cServerSIP.m_objServerSIP.m_objLineList.AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodec, bRegister, sInCallType, sInCallTo) = False Then

            objSendParamList.Add("Unable to add line.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sLineName)

        If (bUpdate) Then
            objTelnetClient.SendCommand("UpdateLine", objSendParamList)
        Else
            objTelnetClient.SendCommand("AddLine", objSendParamList)
        End If

        objTelnetClient.SendText("VaxTele:>")

    End Sub


    Public Sub RemoveLine(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sLineName As String = objParamList.Item(0)
        Dim objSendParamList As New ArrayList

        If Not cServerSIP.m_objServerSIP.m_objLineList.RemoveLine(sLineName) Then

            objSendParamList.Add("Unable to remove line.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sLineName)

        objTelnetClient.SendCommand("RemoveLine", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '/**********************************************/

    Public Sub ShowDialPlans(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry

        Dim objDialPlanList As New ArrayList
        objReg.EnumDialPlan(objDialPlanList)

        Dim objDialPlanReg As New cDialPlanReg
        Dim objSendParamList As New ArrayList

        Dim nCount As Integer

        For nCount = 0 To objDialPlanList.Count - 1

            Dim sUserPrefix As String = objDialPlanList.Item(nCount)
            objReg.GetDialPlan(sUserPrefix, objDialPlanReg)

            If objDialPlanReg.m_sCallPrefix.Length = 0 Then
                objDialPlanReg.m_sCallPrefix = "None"
            End If

            objSendParamList.Add(sUserPrefix + "," + objDialPlanReg.m_sLineName + "," + objDialPlanReg.m_sCallPrefix)

        Next

        objTelnetClient.SendCommand("ShowDialPlans", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub DialPlanInfo(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sUserPrefix As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        Dim objDialPlanReg As New cDialPlanReg

        Dim objSendParamList As New ArrayList

        If objReg.GetDialPlan(sUserPrefix, objDialPlanReg) = False Then

            objSendParamList.Add("DialPlan or user prefix not found.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        objSendParamList.Add(sUserPrefix)
        objSendParamList.Add(objDialPlanReg.m_sLineName)

        If objDialPlanReg.m_sCallPrefix.Length = 0 Then
            objDialPlanReg.m_sCallPrefix = "None"
        End If

        objSendParamList.Add(objDialPlanReg.m_sCallPrefix)

        objTelnetClient.SendCommand("DialPlanInfo", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub AddDialPlan(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sUserPrefix As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        Dim objDialPlanReg As New cDialPlanReg
        Dim objSendParamList As New ArrayList

        objDialPlanReg.m_sLineName = objParamList.Item(1)
        objDialPlanReg.m_sCallPrefix = objParamList.Item(2)

        If objReg.SetDialPlan(sUserPrefix, objDialPlanReg) = False Then

            objSendParamList.Add("Unable to add dialplan or user prefix.")

            objTelnetClient.SendCommand("MSG", objSendParamList)
            objTelnetClient.SendText("VaxTele:>")

            Exit Sub
        End If

        cServerSIP.m_objServerSIP.m_objDialPlanList.ReLoadDialPlans()

        objSendParamList.Add(sUserPrefix)
        objSendParamList.Add(objDialPlanReg.m_sLineName)

        If objDialPlanReg.m_sCallPrefix.Length = 0 Then
            objDialPlanReg.m_sCallPrefix = "None"
        End If

        objSendParamList.Add(objDialPlanReg.m_sCallPrefix)

        objTelnetClient.SendCommand("AddDialPlan", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub RemoveDialPlan(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sUserPrefix As String = objParamList.Item(0)

        Dim objSendParamList As New ArrayList
        Dim objReg As New cRegistry

        If objReg.RemoveDialPlan(sUserPrefix) = False Then

            objSendParamList.Add("Unable to remove dialplan or user prefix.")
            objTelnetClient.SendCommand("MSG", objSendParamList)

            objTelnetClient.SendText("VaxTele:>")
            Exit Sub
        End If

        cServerSIP.m_objServerSIP.m_objDialPlanList.ReLoadDialPlans()

        objSendParamList.Add(sUserPrefix)

        objTelnetClient.SendCommand("RemoveDialPlan", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '/*************************************************/

    Public Sub SetStealthMusic(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sStealthMusic As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        objReg.SetStealthListenerMusic(sStealthMusic)

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(sStealthMusic)

        objTelnetClient.SendCommand("SetStealthMusic", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub GetStealthMusic(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(objReg.GetStealthListenerMusic())

        objTelnetClient.SendCommand("GetStealthMusic", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '/*************************************************/

    Public Sub SetHoldMusic(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sHoldMusic As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        objReg.SetHoldMusic(sHoldMusic)

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(sHoldMusic)

        objTelnetClient.SendCommand("SetHoldMusic", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub GetHoldMusic(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(objReg.GetHoldMusic())

        objTelnetClient.SendCommand("GetHoldMusic", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '/*************************************************/

    Public Sub SetDialToneMusic(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim sDialToneMusic As String = objParamList.Item(0)

        Dim objReg As New cRegistry
        objReg.SetDialToneMusic(sDialToneMusic)

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(sDialToneMusic)

        objTelnetClient.SendCommand("SetDialToneMusic", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    Public Sub GetDialToneMusic(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry

        Dim objSendParamList As New ArrayList
        objSendParamList.Add(objReg.GetDialToneMusic())

        objTelnetClient.SendCommand("GetDialToneMusic", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '/*************************************************/

    Public Sub GetCOMM(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry
        Dim objDialPlanReg As New cDialPlanReg

        Dim sListenIP As String = ""
        Dim sListenPort As String = ""
        Dim sDominRealm As String = ""

        objReg.GetComm(sListenIP, sListenPort, sDominRealm)

        Dim objSendParamList As New ArrayList

        objSendParamList.Add(sListenIP)
        objSendParamList.Add(sListenPort)
        objSendParamList.Add(sDominRealm)

        objTelnetClient.SendCommand("GetCOMM", objSendParamList)
        objTelnetClient.SendText("VaxTele:>")
    End Sub

    Public Sub SetCOMM(ByRef objParamList As ArrayList, ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry
        Dim objDialPlanReg As New cDialPlanReg

        Dim sListenIP = objParamList.Item(0)
        Dim sListenPort = objParamList.Item(1)
        Dim sDominRealm = objParamList.Item(2)

        objReg.SetComm(sListenIP, sListenPort, sDominRealm)

        objTelnetClient.SendCommand("SetCOMM", objParamList)
        objTelnetClient.SendText("VaxTele:>")

    End Sub

    '///////////////////////////////////////////

    Public Sub StartServer(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry
        objReg.SetStartServer(True)

        objTelnetClient.SendText("VaxTele:>")
    End Sub

    Public Sub StopServer(ByRef objTelnetClient As cTelnetClient)

        Dim objReg As New cRegistry
        objReg.SetStartServer(False)

        objTelnetClient.SendText("VaxTele:>")
    End Sub

    '/////////////////////////////////////////

    Public Sub InvalidCommand(ByRef objTelnetClient As cTelnetClient)

        objTelnetClient.SendText("VaxTele:>")
    End Sub

    '/////////////////////////////////////////

    Public Sub ParseToList(ByVal sInputStr As String, ByRef objOutputList As ArrayList)

        Dim nEnd As Integer = 0

        While sInputStr.Length <> 0

            nEnd = sInputStr.IndexOf(",")

            If (nEnd = -1) Then
                objOutputList.Add(sInputStr)
                Exit While
            End If

            objOutputList.Add(sInputStr.Substring(0, nEnd))
            sInputStr = sInputStr.Remove(0, nEnd + 1)

        End While

    End Sub

    Public Sub PrepareToStr(ByRef objInputList As ArrayList, ByRef sOutputStr As String)

        sOutputStr = ""
        Dim nCount As Integer = 0

        For nCount = 0 To objInputList.Count - 1
            sOutputStr = sOutputStr + objInputList.Item(nCount) + ","

            If nCount > 0 Then
                sOutputStr = sOutputStr.Remove(sOutputStr.Length - 1, 1) 'remove last comma ','
            End If
        Next

    End Sub

End Class
