Public Class cUserData

    Public m_nCallCount As Integer
    Public m_unUserId As UInteger

    Public m_bStealthListener As Boolean
    Public m_sCodecList As String
    Public m_sUserId As String

    Public m_bBlock As Boolean

    Public Sub New()

        m_nCallCount = 0
        m_unUserId = 0
        m_bStealthListener = False
        m_bBlock = False

        m_sCodecList = ""

    End Sub

End Class

Public Class cUserList

    Dim m_unUserIdCount As UInteger = 0

    Dim m_objUserListTEXT As New Hashtable(256)
    Dim m_objUserListINT As New Hashtable(256)

    Public Function ChooseUserId() As UInteger

        While (True)
            m_unUserIdCount += 1

            If FindUser(m_unUserIdCount) Is Nothing Then
                Exit While
            End If
        End While

        ChooseUserId = m_unUserIdCount

    End Function

    Public Function AddUser(ByVal sUserId As String, ByVal sUserPwd As String, ByVal bStealthListener As Boolean, ByVal sCodecList As String, ByVal bBlock As Boolean) As Boolean

        If cServerSIP.m_objServerSIP.AddUser(sUserId, sUserPwd) = False Then
            cServerSIP.m_objServerSIP.LogError("")
            AddUser = False
            Exit Function
        End If

        Remove(sUserId)
        Add(sUserId, bStealthListener, sCodecList, bBlock)

        AddUser = True

    End Function

    Public Sub RemoveUser(ByVal sUserId As String)

        cServerSIP.m_objServerSIP.RemoveUser(sUserId)
        Remove(sUserId)

    End Sub

    Public Function FindUser(ByVal unUserId As UInteger) As cUserData
        FindUser = m_objUserListINT.Item(unUserId)
    End Function

    Public Function FindUser(ByVal sUserId As String) As cUserData
        FindUser = m_objUserListTEXT.Item(sUserId.ToLower())
    End Function

    Public Sub DeleteAll()
        m_objUserListTEXT.Clear()
        m_objUserListINT.Clear()
    End Sub

    Public Function GetCallCount(ByVal sUserId As String) As Integer

        Dim objUserData As cUserData = FindUser(sUserId)

        If objUserData Is Nothing Then
            GetCallCount = -1
            Exit Function
        End If

        GetCallCount = objUserData.m_nCallCount

    End Function

    Private Sub Add(ByVal sUserId As String, ByVal bStealthListener As Boolean, ByVal sCodecList As String, ByVal bBlock As Boolean)

        Dim objUserData As cUserData = New cUserData()

        objUserData.m_sUserId = sUserId
        objUserData.m_unUserId = ChooseUserId()
        objUserData.m_bStealthListener = bStealthListener
        objUserData.m_sCodecList = sCodecList
        objUserData.m_bBlock = bBlock

        m_objUserListINT.Add(objUserData.m_unUserId, objUserData)
        m_objUserListTEXT.Add(sUserId.ToLower(), objUserData)

    End Sub

    Private Sub Remove(ByVal sUserId As String)

        sUserId = sUserId.ToLower()
        Dim objUserData As cUserData = m_objUserListTEXT.Item(sUserId)

        If objUserData Is Nothing Then
            Exit Sub
        End If

        m_objUserListINT.Remove(objUserData.m_unUserId)
        m_objUserListTEXT.Remove(sUserId)

        objUserData = Nothing

    End Sub

    Public Function GetCount() As Integer
        GetCount = m_objUserListINT.Count
    End Function

End Class
