#include "StdAfx.h"
#include "ClientRegisterEvent.h"
#include "Registry.h"
#include "ServerSIP.h"
#include "UserList.h"

using namespace System;
using namespace System::Collections;
using namespace System::Text;

cClientRegisterEvent::cClientRegisterEvent(void)
{
	m_objDomainRealm = gcnew String("");
}

void cClientRegisterEvent::SetDomainRealm(String^ sDomainRealm)
{
    m_objDomainRealm = sDomainRealm;  //Restrict client to add correct domain in the ToURI.
}

void cClientRegisterEvent::OnClientRegister(String^ sUserLogin, String^ sDomain, int nRegId)
{
    //if(m_sDomainRealm != sDomain)  // Restrict client to add correct domain in the ToURI.
    //{
    //	RejectClientRegister(nRegId);
    //	return;
    //}

    cRegistry^ objReg = gcnew cRegistry();
    cLoginReg^ objLoginReg = gcnew cLoginReg();

    if (!objReg->GetLogin(sUserLogin, objLoginReg))
    {
        if (!cServerSIP::m_objServerSIP->RejectClientRegister(nRegId))
            cServerSIP::m_objServerSIP->LogError("");

        return;
    }

    if (objLoginReg->m_bBlock)
    {
        if (!cServerSIP::m_objServerSIP->RejectClientRegister(nRegId))
            cServerSIP::m_objServerSIP->LogError("");

        return;
    }

    cServerSIP::m_objServerSIP->m_objUserList->AddUser(sUserLogin, objLoginReg->m_sPassword, objLoginReg->m_bStealth, objLoginReg->m_sCodec, objLoginReg->m_bBlock);

    if (!cServerSIP::m_objServerSIP->AuthClientRegister(nRegId))
        cServerSIP::m_objServerSIP->LogError("");
}

void cClientRegisterEvent::OnClientRegisterSuccess(String^ sUserLogin)
{
}

void cClientRegisterEvent::OnClientUnRegister(String^ sUserLogin)
{
    cServerSIP::m_objServerSIP->m_objUserList->RemoveUser(sUserLogin);
}

void cClientRegisterEvent::OnClientRegisterFail(String^ sUserLogin)
{
    cServerSIP::m_objServerSIP->m_objUserList->RemoveUser(sUserLogin);
}
