// VaxTeleConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleConfigSIP.h"
#include "VaxTeleConfigDlg.h"
#include "AddLineDlg.h"
#include "AddLoginDlg.h"
#include "GeneralDlg.h"
#include "AddQueueDlg.h"
#include "TelnetClient.h"
#include "AddDialplanDlg.h"
#include "ErrorLogDlg.h"
#include "StatusLogDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVaxTeleConfigDlg

IMPLEMENT_DYNAMIC(CVaxTeleConfigDlg, CMySheet)

CVaxTeleConfigDlg* CVaxTeleConfigDlg::m_pVaxTeleConfigDlg = NULL;

CVaxTeleConfigDlg::CVaxTeleConfigDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CMySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

CVaxTeleConfigDlg::CVaxTeleConfigDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CMySheet(pszCaption, pParentWnd, iSelectPage)
{
	CVaxTeleConfigDlg::m_pVaxTeleConfigDlg = this;
	
	m_psh.dwFlags |= PSH_NOAPPLYNOW;   // Lose the Apply Now button
	m_psh.dwFlags &= ~PSH_HASHELP;     // Lose the Help button
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pAddLoginDlg    = new CAddLoginDlg;
	m_pGeneralDlg     = new CGeneralDlg;
	
	m_pAddLineDlg     = new CAddLineDlg;
	m_pAddDialplanDlg = new CAddDialplanDlg;
	
	m_pAddQueueDlg    = new CAddQueueDlg;
	
	m_pErrorLogDlg    = new CErrorLogDlg;
	m_pStatusLogDlg   = new CStatusLogDlg;
	
	
	AddPage(m_pGeneralDlg);
	AddPage(m_pAddLoginDlg);

	AddPage(m_pAddLineDlg);
	AddPage(m_pAddDialplanDlg);

	AddPage(m_pAddQueueDlg);
	AddPage(m_pErrorLogDlg);
	AddPage(m_pStatusLogDlg);
}

CVaxTeleConfigDlg::~CVaxTeleConfigDlg()
{
	delete m_pAddLoginDlg;
	delete m_pGeneralDlg;
	delete m_pAddLineDlg;
	delete m_pAddQueueDlg;
	delete m_pAddDialplanDlg;

	delete m_pErrorLogDlg;
	delete m_pStatusLogDlg;
}


BEGIN_MESSAGE_MAP(CVaxTeleConfigDlg, CMySheet)
	//{{AFX_MSG_MAP(CVaxTeleConfigDlg)
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxTeleConfigDlg message handlers

BOOL CVaxTeleConfigDlg::OnInitDialog() 
{
	BOOL bResult = CMySheet::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	((CButton*) GetDlgItem(IDOK))->ShowWindow(SW_HIDE);
	((CButton*) GetDlgItem(IDCANCEL))->ShowWindow(SW_HIDE);
				
	return bResult;
}

HCURSOR CVaxTeleConfigDlg::OnQueryDragIcon() 
{
	return (HCURSOR) m_hIcon;
}

void CVaxTeleConfigDlg::OnTelnetCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	if(::lstrcmpi(sCommand, "GetDialToneMusic") == 0 || ::lstrcmpi(sCommand, "GetStealthMusic") == 0 ||
	   ::lstrcmpi(sCommand, "GetHoldMusic") == 0     || ::lstrcmpi(sCommand, "StatusServerSIP") == 0)
	{
		m_pGeneralDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}
	
	if(::lstrcmpi(sCommand, "GetCallCount") == 0 || ::lstrcmpi(sCommand, "GetUserCount") == 0 ||
	   ::lstrcmpi(sCommand, "GetUsageCPU") == 0  || ::lstrcmpi(sCommand, "GetAvailMEM") == 0 )
	{
		m_pGeneralDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}
	
	if(::lstrcmpi(sCommand, "GetCOMM") == 0 || ::lstrcmpi(sCommand, "SetCOMM") == 0)
	{
		m_pGeneralDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}

	////////////////////////////////////////

	if(::lstrcmpi(sCommand, "ShowUsers") == 0)
	{
		m_pAddLoginDlg->OnTelnetCommand(sCommand, pParamList);
		m_pAddQueueDlg->OnTelnetCommand(sCommand, pParamList);
		m_pAddLineDlg->OnTelnetCommand(sCommand, pParamList);

		return;
	}
	
	if(::lstrcmpi(sCommand, "RemoveUser") == 0 || ::lstrcmpi(sCommand, "AddUser") == 0)
	{
		m_pAddLoginDlg->OnTelnetCommand(sCommand, pParamList);
		m_pAddQueueDlg->OnTelnetCommand(sCommand, pParamList);
		m_pAddLineDlg->OnTelnetCommand(sCommand, pParamList);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateUser") == 0 || ::lstrcmpi(sCommand, "UserInfo") == 0)
	{
		m_pAddLoginDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}

	////////////////////////////////////////
	
	if(::lstrcmpi(sCommand, "RemoveQueue") == 0 || ::lstrcmpi(sCommand, "AddQueue") == 0 || 
	   ::lstrcmpi(sCommand, "ShowQueues") == 0)
	{
		m_pAddQueueDlg->OnTelnetCommand(sCommand, pParamList);
		m_pAddLineDlg->OnTelnetCommand(sCommand, pParamList);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateQueue") == 0 || ::lstrcmpi(sCommand, "QueueInfo") == 0)
	{
		m_pAddQueueDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}

	////////////////////////////////////////
		
	if(::lstrcmpi(sCommand, "RemoveLine") == 0 || ::lstrcmpi(sCommand, "AddLine") == 0 ||
	   ::lstrcmpi(sCommand, "ShowLines") == 0)
	{
		m_pAddLineDlg->OnTelnetCommand(sCommand, pParamList);
		m_pAddDialplanDlg->OnTelnetCommand(sCommand, pParamList);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateLine") == 0 || ::lstrcmpi(sCommand, "LineInfo") == 0)
	{
		m_pAddLineDlg->OnTelnetCommand(sCommand, pParamList);

		return;
	}

	////////////////////////////////////////

	if(::lstrcmpi(sCommand, "ShowDialPlans") == 0)
	{
		m_pAddDialplanDlg->OnTelnetCommand(sCommand, pParamList);
		
		return;
	}
	
	if(::lstrcmpi(sCommand, "RemoveDialPlan") == 0 || ::lstrcmpi(sCommand, "AddDialPlan") == 0)
	{
		m_pAddDialplanDlg->OnTelnetCommand(sCommand, pParamList);

		return;
	}

	if(::lstrcmpi(sCommand, "UpdateDialPlan") == 0 || ::lstrcmpi(sCommand, "DialPlanInfo") == 0)
	{
		m_pAddDialplanDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}

	////////////////////////////////////////

	if(::lstrcmpi(sCommand, "ErrorLog") == 0)
	{
		m_pErrorLogDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}

	if(::lstrcmpi(sCommand, "StatusLog") == 0)
	{
		m_pStatusLogDlg->OnTelnetCommand(sCommand, pParamList);
		return;
	}

	////////////////////////////////////////

	if(::lstrcmpi(sCommand, "MSG") == 0 && pParamList->GetCount() == 1)
	{
		MessageBox(pParamList->GetHead(), "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);

		return;
	}
}

void CVaxTeleConfigDlg::SendCommand(LPCTSTR sCommand, CStringList* pParamList)
{
	m_pTelnetClient->SendCommand(sCommand, pParamList);
}

void CVaxTeleConfigDlg::ParseToStringList(CString objString, CStringList* pStringList) 
{
	while(!objString.IsEmpty())
	{
		int nEnd = objString.Find(",");
		
		if(nEnd == -1)
		{
			pStringList->AddTail(objString);
			break;
		}

		pStringList->AddTail(objString.Left(nEnd));
		objString.Delete(0, nEnd + 1);
	}	
}
