// CallEvent.h: interface for the CCallEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CALLEVENT_H__031AD3DA_B6A4_4D29_B94A_830DCDABACE9__INCLUDED_)
#define AFX_CALLEVENT_H__031AD3DA_B6A4_4D29_B94A_830DCDABACE9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCallData;
class CUserData;
class CLineData;

class CCallEvent  
{
public:
	CCallEvent();
	virtual ~CCallEvent();

public:

	void OnIncomingCallFromLine(CCallData* pCallData, CLineData* pLineData, LPCTSTR sDialNo);
	void OnIncomingCallFromUser(CCallData* pFromCallData, CUserData* pFromUserData, LPCTSTR sDialNo);

	void OnIncomingCallQueueType(CCallData* pCallData, ULONG lQueueId);
	void OnIncomingCallRegularType(CCallData* pCallData, CUserData* pUserData, LPCTSTR sDialNo);
	void OnIncomingCallStealthType(CCallData* pCallData, CUserData* pUserData, LPCTSTR sDialNo);

	void OnIncomingCallCancel(CCallData* pCallData);
	
	void OnDialCallConnected(CCallData* pCallData);
	void OnAcceptIncomingCallConnected(CCallData* pCallData);

	void OnConnectedCallRegularType(CCallData* pCallData);
	void OnConnectedCallStealthType(CCallData* pCallData);
	void OnConnectedCallQueueType(CCallData* pCallData);
	
	void OnDisconnectCall(CCallData* pCallData);
	void OnSessionLost(CCallData* pCallData);
	
	void OnDialCallTimeOut(CCallData* pCallData);
	void OnAcceptCallTimeOut(CCallData* pCallData);

};

#endif // !defined(AFX_CALLEVENT_H__031AD3DA_B6A4_4D29_B94A_830DCDABACE9__INCLUDED_)
