// CallList.h: interface for the CCallList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CALLLIST_H__15F2C2DB_7ABA_459C_BFE6_477AF6FB56FC__INCLUDED_)
#define AFX_CALLLIST_H__15F2C2DB_7ABA_459C_BFE6_477AF6FB56FC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CQueueData;

class CCallData
{

public:

	CCallData()
	{
		m_lCallId       = -1;

		m_lSessionId    = -1;
		m_lUserId       = 0;
		m_nCallType     = 0;
		m_lQueueId      = 0;
		m_nDigitPRESS   = 0;
		m_lStealthId    = 0;

		m_pBindCallData = NULL;
		m_bDigitDetect = FALSE;

		m_bConnected = FALSE;
		m_bStealthListening = FALSE;
		
		m_nPlayWaveType = PLAY_WAVE_NONE_TYPE;
	}

public:

	long m_lCallId;

	long m_lSessionId;
	BOOL m_bConnected;
	BOOL m_bStealthListening;
	
	ULONG m_lQueueId;
	ULONG m_lUserId;

	int m_nCallType;
	CString m_sCallerId;
	CString m_sUserId;
	
	CString m_sDigitPRESS;
	int m_nDigitPRESS;
	BOOL m_bDigitDetect;

	ULONG m_lStealthId;
	CString m_sStealthDialNo;

	CString m_sCodec;
	CCallData* m_pBindCallData;

	int m_nPlayWaveType;
};


class CCallList : public CMap <long, long, CCallData*, CCallData*>
{

public:
	
	CCallList();
	~CCallList();

public:

	CCallData* AddCall(long lCallId);
	CCallData* FindCall(long lCallId);
	
	void RemoveCall(CCallData* pCallData);
	void DeleteAll();
};

#endif // !defined(AFX_CALLLIST_H__15F2C2DB_7ABA_459C_BFE6_477AF6FB56FC__INCLUDED_)
