// TelnetRequest.cpp: implementation of the CTelnetRequest class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TelnetRequest.h"
#include "TelnetClient.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTelnetRequest::CTelnetRequest()
{

}

CTelnetRequest::~CTelnetRequest()
{

}

void CTelnetRequest::FillRecvBuffer(CTelnetClient* pTelnetClient)
{
	while(TRUE)
	{
		char sBuffer[2048] = "\0";
		int nSize = pTelnetClient->Receive(sBuffer, 2048);

		if(nSize == SOCKET_ERROR || nSize == 0)
			break;
	
		for(int nCount = 0; nCount < nSize; nCount++)
		{
			if(sBuffer[nCount] == 8) // Client press backspace.
			{
				if(m_sRecvBuffer.IsEmpty())
					return;
											
				char sSendData[] = {32, 8};
				pTelnetClient->Send(sSendData, 2);
				
				m_sRecvBuffer.Delete(m_sRecvBuffer.GetLength() - 1);
			}
			else
			{
				m_sRecvBuffer += sBuffer[nCount];
			}
		}
	}
}


CString CTelnetRequest::FindRequest(CTelnetClient* pTelnetClient)
{
	int nStart = m_sRecvBuffer.Find("\r\n");
	if(nStart == -1) return "";
	
	CString sCommand = m_sRecvBuffer.Left(nStart);
	m_sRecvBuffer.Delete(0, nStart + 2);

	if(sCommand.IsEmpty())
		pTelnetClient->SendText("VaxTele:>");

	return sCommand;
}


BOOL CTelnetRequest::ParseRequest(CString objRequest, CString& objCommand, CStringList* pParamList)
{
	int nEnd = objRequest.Find(" ", 0);
	
	if(nEnd == -1) 
	{
		objCommand = objRequest;
		return TRUE;
	}

	objCommand = objRequest.Left(nEnd);
	objRequest.Delete(0, nEnd + 1);
		
	while(TRUE)
	{
		nEnd = objRequest.Find(" ");
		
		if(nEnd == -1) 
		{	
			pParamList->AddTail(objRequest);
			break;
		}
		
		pParamList->AddTail(objRequest.Left(nEnd));
		objRequest.Delete(0, nEnd + 1);
	}

	return TRUE;
}


