// VaxTeleCOM.h: interface for the CVaxTeleCOM class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VAXTELECOM_H__C7F2AE05_C15E_4018_AC72_5FFA3167017A__INCLUDED_)
#define AFX_VAXTELECOM_H__C7F2AE05_C15E_4018_AC72_5FFA3167017A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#import "VaxTeleServerSIP.dll" rename_namespace("VaxTeleServer")
using namespace VaxTeleServer;

class CVaxTeleCOM : public CCmdTarget
{

	DECLARE_DYNCREATE(CVaxTeleCOM)

public:

	CVaxTeleCOM();
	~CVaxTeleCOM();

// Attributes
public:

	DWORD m_dwCookie;
	
	_IVaxTeleSIPEvents* m_pVaxTeleSIPEvents;
	IVaxTeleSIP* m_pVaxTeleSIP;

	void SetLicenseKey(LPCTSTR sLicenseKey);
	
	BOOL InitObjectCOM();
	void UnInitObjectCOM();
		
	void UnInitialize();
	BOOL Initialize(LPCTSTR sDomainName, LPCTSTR sSIPListenIP, UINT nSIPListenPort, LPCTSTR sRTPListenIP, UINT nRTPListenPort);
	
	BOOL AcceptCall(LONG lCallId, LPCTSTR sCodecList, LONG lTimeOut);
	BOOL CloseCall(LONG lCallId);

	LONG CreateSession();
	BOOL AddCallToSession(LONG lCallId, LONG lSessionId);
	BOOL RemoveCallToSession(LONG lCallId);
	void CloseSession(LONG lSessionId);

	LONG GetVaxObjectError();

	LONG DialCallToUser(LPCTSTR sCallFrom, LPCTSTR sToUserLogin, LPCTSTR sCodecList, LONG lTimeOut);
	LONG DialCallToLine(LONG lLineId, LPCTSTR sDialNo, LPCTSTR sCodecList, LONG lTimeOut);
	LONG DialCallToURI(LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sProxyURI, LPCTSTR sLogin, LPCTSTR sLoginPwd, LPCTSTR sCodecList, LONG lTimeOut);
	
	BOOL SendResponse(LONG lCallId, int nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sCodecList);

	BOOL RegisterLine(LONG lLineId);
	BOOL UnRegisterLine(LONG lLineId);

	BOOL AddLine(LONG lLineId, LPCTSTR sUserName, LPCTSTR sLogin, LPCTSTR sLoginPwd, LPCTSTR sDisplayName, LPCTSTR sDomainRealm, LPCTSTR sProxyURI, LPCTSTR sOutboundProxy);
	void RemoveLine(LONG lLineId);

	BOOL AddUser(LPCTSTR sUserLogin, LPCTSTR sLoginPwd);
	void RemoveUser(LPCTSTR sUserLogin);
		
	BOOL AuthClientRegister(LONG lRegId);
	BOOL AcceptClientRegister(LONG lRegId);
	BOOL RejectClientRegister(LONG lRegId);

	LONG PlayWaveLoadFile(LPCTSTR sFileName);
	void PlayWaveUnLoadFile(LONG lPlayWaveId);
	BOOL PlayWaveStartToSession(LONG lPlayWaveId, LONG lSessionId, BOOL bLoopPlay);
	BOOL PlayWaveStopToSession(LONG lSessionId);
	BOOL PlayWaveResetToSession(LONG lSessionId);

	BOOL RecordWaveStartToSession(LPCTSTR sFileName, LONG lSessionId);
	BOOL RecordWaveStopToSession(LONG lSessionId);
	BOOL RecordWavePauseToSession(BOOL bEnable, LONG lSessionId);

	BOOL TransferCallAccept(LONG lCallId);
	BOOL TransferCallReject(LONG lCallId);

	BOOL SendDTMF(int nTypeDTMF, LONG lCallId, int nDigit);
	BOOL DetectDTMF(int nTypeDTMF, LONG lSessionId, BOOL bEnable);

	BOOL SessionLost(BOOL bEnable);
	LONG GetCallSession(LONG lCallId);

	BOOL EnableDialTone(LONG lCallId, LONG lSessionId);
	BOOL DisableDialTone(LONG lCallId);

	BOOL SetVaxTeleTick(LONG lTickId, LONG lElapse);
	BOOL KillVaxTeleTick(LONG lTickId);

	int GetCallTxCodecNo(LONG lCallId);
	int GetCallRxCodecNo(LONG lCallId);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVaxTeleCOM)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
public:
	
	// Generated message map functions
	//{{AFX_MSG(CVaxTeleCOM)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	//afx_msg void OnClientUnRegister(LPCTSTR sUserLogin);
	//	afx_msg void OnClientRegister(LPCTSTR sUserLogin, LONG lRegId);

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CVaxTeleCOM)
	afx_msg virtual void OnClientUnRegister(LPCTSTR sUserLogin);
	afx_msg virtual void OnClientRegister(LPCTSTR sUserLogin, LPCTSTR sDomain, long lRegId);
	afx_msg virtual void OnClientRegisterSuccess(LPCTSTR sUserLogin);
	afx_msg virtual void OnClientRegisterFail(LPCTSTR sUserLogin);
	afx_msg virtual void OnLineRegisterTrying(long lLineId);
	afx_msg virtual void OnLineRegisterFail(long lLineId, long lStatusCode, LPCTSTR sReasonPhrase);
	afx_msg virtual void OnLineRegisterSuccess(long lLineId);
	afx_msg virtual void OnIncomingCallFromLine(long lCallId, long lLineId, LPCTSTR sCallFrom, LPCTSTR sCallTo, LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sFromIP, long lFromPort);
	afx_msg virtual void OnIncomingCallFromUser(long lCallId, LPCTSTR sUserName, LPCTSTR sCallFrom, LPCTSTR sCallTo, LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sFromIP, long lFromPort);
	afx_msg virtual void OnIncomingCallAnonymous(long lCallId, LPCTSTR sCallFrom, LPCTSTR sCallTo, LPCTSTR sFromURI, LPCTSTR sToURI, LPCTSTR sFromIP, long lFromPort);
	afx_msg virtual void OnIncomingCallCancel(long lCallId);
	afx_msg virtual void OnDialCallConnected(long lCallId);
	afx_msg virtual void OnAcceptIncomingCallConnected(long lCallId);
	afx_msg virtual void OnDisconnectCall(long lCallId);
	afx_msg virtual void OnProvisionalResponse(long lCallId, long lStatusCode, LPCTSTR sReasonPhrase);
	afx_msg virtual void OnFailureResponse(long lCallId, long lStatusCode, LPCTSTR sReasonPhrase);
	afx_msg virtual void OnRedirectionResponse(long lCallId, long lStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContact);
	afx_msg virtual void OnPlayWaveToSessionDone(long lPlayWaveId, long lSessionId);
	afx_msg virtual void OnDigitDetectDTMF(long lSessionId, long lCallId, long lDigit);
	afx_msg virtual void OnSessionLost(long lCallId);
	afx_msg virtual void OnTransferCallBlind(long lCallId, LPCTSTR sTransferee, LPCTSTR sTransferTo, LPCTSTR sTransferToURI);
	afx_msg virtual void OnTransferCallAttend(long lCallId, long lTransferToCallId);
	afx_msg virtual void OnHoldCall(long lCallId);
	afx_msg virtual void OffHoldCall(long lCallId);
	afx_msg virtual void OnDialCallTimeOut(long lCallId);
	
	afx_msg virtual void OnLineUnRegisterTrying(long lLineId);
	afx_msg virtual void OnLineUnRegisterFail(long lLineId);
	afx_msg virtual void OnLineUnRegisterSuccess(long lLineId);

	afx_msg virtual void OnAcceptCallTimeOut(long lCallId);
	afx_msg virtual void OnVaxTeleTick(long lTickId);
	
	
	
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

};

#endif // !defined(AFX_VAXTELECOM_H__C7F2AE05_C15E_4018_AC72_5FFA3167017A__INCLUDED_)
