using System;
using System.Collections;
using System.Text;


class cStealthData
{
    
    public uint m_unStealthIdCount;
    private Hashtable m_objStealthListINT = new Hashtable();
    private Hashtable m_objStealthListTEXT = new Hashtable();

    public cStealthData()
    {
        m_unStealthIdCount = 0;
    }
}

class cStealthList
{
    uint m_unStealthIdCount;

    Hashtable m_objStealthListTEXT = new Hashtable();
    Hashtable m_objStealthListINT = new Hashtable();

    public cStealthList()
    {
        m_unStealthIdCount = 0;
    }

    public uint ChooseStealthId()
    {
        while (true)
        {
            m_unStealthIdCount++;

            if (FindStealthCall(m_unStealthIdCount) == null)
                break;
        }

        return m_unStealthIdCount;
    }

    public void AddCallToStealthList(ref cCallData objCallData)
    {
        objCallData.m_unStealthId = ChooseStealthId();

        m_objStealthListINT.Add(objCallData.m_unStealthId, objCallData);
        m_objStealthListTEXT.Add(objCallData.m_sStealthDialNo, objCallData);
    }

    public void FreeCaptureCall(ref cCallData objCallData)
    {
        if(objCallData.m_unStealthId != 0)
        {
            cCallData objStealthCallData = FindStealthCall(objCallData.m_unStealthId);

            if(objStealthCallData != null)
            {
                objStealthCallData.m_bStealthListening = false;

                int nStealthSessionId = cServerSIP.m_objServerSIP.m_objServerData.GetStealthSessionId();
                cServerSIP.m_objServerSIP.AddCallToSession(ref objStealthCallData, nStealthSessionId);
            }
	    }
    }

    public void TryCaptureCall(ref cCallData objCallData)
    {
        cCallData objStealthCallData = FindStealthCall(objCallData.m_sUserId);

        if(objStealthCallData == null)
            return;

        if (objStealthCallData.m_bStealthListening == true)
            return;
        
        cServerSIP.m_objServerSIP.AddCallToSession(ref objStealthCallData, objCallData.m_nSessionId);

        objStealthCallData.m_bStealthListening = true;
        objCallData.m_unStealthId = objStealthCallData.m_unStealthId;
    }

    public cCallData FindStealthCall(uint unStealthId)
    {
        return (cCallData) m_objStealthListINT[unStealthId];
    }

    public cCallData FindStealthCall(string sDialNo)
    {
        return (cCallData) m_objStealthListTEXT[sDialNo.ToLower()];
    }

    public void RemoveStealthCall(ref cCallData objCallData)
    {
        m_objStealthListINT.Remove(objCallData.m_unStealthId);
        m_objStealthListTEXT.Remove(objCallData.m_sStealthDialNo);
    }

    public void DeleteAll()
    {
        m_objStealthListTEXT.Clear();
        m_objStealthListINT.Clear();
    }
    
}

